/*
  Copyright (C) 2008  Hideki EIRAKU
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
*/

#include <windows.h>
#include "about.h"
#include "resource.h"

#define ABOUTDLGNAME MAKEINTRESOURCE (IDD_DIALOG2)
#define ABOUTDLGNAME_MENU MAKEINTRESOURCE (IDR_MENU1)
#define ABOUTDLGID_URLBUTTON 502
#define ABOUTDLGID_MENUCOPY ID_MENUITEM40001

static BOOL CALLBACK
aboutdlgproc (HWND hwnd, UINT msg, WPARAM w, LPARAM l)
{
  if (msg == WM_INITDIALOG)
    return 1;
  if (msg == WM_COMMAND)
    {
      switch (LOWORD (w))
	{
	case IDCANCEL:
	  if (HIWORD (w) == BN_CLICKED)
	    EndDialog (hwnd, 0);
	  break;
	case ABOUTDLGID_URLBUTTON:
	  if (HIWORD (w) == BN_CLICKED)
	    {
	      TCHAR buf[256];
	      
	      GetWindowText (GetDlgItem (hwnd, ABOUTDLGID_URLBUTTON), buf,
			     256);
	      ShellExecute (hwnd, 0, buf, 0, TEXT (""), 0);
	    }
	  break;
	case ABOUTDLGID_MENUCOPY:
	  if (OpenClipboard (hwnd))
	    {
	      TCHAR *buf;
	      HGLOBAL hg;
	      HWND btn;
	      int ll;

	      btn = GetDlgItem (hwnd, ABOUTDLGID_URLBUTTON);
	      hg = GlobalAlloc (GMEM_DDESHARE, sizeof (TCHAR) *
				(ll = (GetWindowTextLength (btn) + 1)));
	      if (hg)
		{
		  buf = GlobalLock (hg);
		  GetWindowText (GetDlgItem (hwnd, ABOUTDLGID_URLBUTTON), buf,
				 ll);
		  GlobalUnlock (hg);
		  EmptyClipboard ();
#if defined (UNICODE)
		  SetClipboardData (CF_UNICODETEXT, hg);
#else
		  SetClipboardData (CF_TEXT, hg);
#endif
		}
	      CloseClipboard ();
	    }
	  break;
	}
      return 1;
    }
  if (msg == WM_CONTEXTMENU)
    {
      HWND btn;

      btn = GetDlgItem (hwnd, ABOUTDLGID_URLBUTTON);
      if ((HWND)w == btn)
	{
	  int x = 0, y = 0;
	  HMENU hmenu;

	  if ((unsigned long int)l == 4294967295UL)
	    {
	      RECT rc;

	      if (GetWindowRect (btn, &rc))
		{
		  x = (rc.left + rc.right) / 2;
		  y = (rc.top + rc.bottom) / 2;
		}
	    }
	  else
	    {
	      x = LOWORD (l);
	      y = HIWORD (l);
	    }
	  hmenu = LoadMenu (GetModuleHandle (0), ABOUTDLGNAME_MENU);
	  if (hmenu)
	    {
	      TrackPopupMenu (GetSubMenu (hmenu, 0),
			      TPM_LEFTALIGN | TPM_TOPALIGN | TPM_LEFTBUTTON
			      | TPM_RIGHTBUTTON, x, y, 0, hwnd, 0);
	      DestroyMenu (hmenu);
	    }
	  return 1;
	}
    }
  return 0;
}

void
aboutdlg (HWND hwnd)
{
  DialogBox (GetModuleHandle (0), ABOUTDLGNAME, hwnd, aboutdlgproc);
}
