/*
  Copyright (C) 2000-2008  Hideki EIRAKU
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
*/

#include <windows.h>
#include <commctrl.h>
#include <stdlib.h>
#include <ddk/ntapi.h>
#include "about.h"
#include "icon.h"
#include "options.h"
#include "resource.h"

#define ID_ABOUT 192
#define ID_OPTIONS 193

int traymode;
int opt_i, opt_t;
int ntmode;
int opt_w;
int opt_R, opt_F, opt_S;
int screenx, screeny;
HWND traywnd;

HANDLE hvxd;
DWORD buf2[0x1000], nowtime, nowidle, oldtime, oldidle;
HICON hicon, hexeicon;
HINSTANCE hinst;
HMENU hmenu;

BYTE
regaccess (char *s, int f)
{
  HKEY hkey;
  LONG r;
  BYTE val[4];
  DWORD l, t;
  char buf[32];

  lstrcpy (buf, "PerfStats\\");
  lstrcat (buf, s);
  if (RegOpenKeyEx (HKEY_DYN_DATA, buf, 0, KEY_QUERY_VALUE, &hkey)
      != ERROR_SUCCESS)
    return 128;
  lstrcpy (buf, "KERNEL");
  if (f)
    lstrcat (buf, "\\CPUUsage");
  l = sizeof (val);
  t = REG_BINARY;
  r = RegQueryValueEx (hkey, buf, 0, &t,
		       val, &l);
  RegCloseKey (hkey);
  if (r != ERROR_SUCCESS)
    return 129;
  if (l != 4)
    return 130;
  if (val[0] > 100)
    return 100;
  return val[0];
}

int
getcpu (void)
{
  DWORD dd;
  DWORD i;
  
  if (ntmode)
    {
      union {
	SYSTEM_PROCESSOR_TIMES pt;
	BYTE x[48];
      } pt[10];
      ULONG retlen, i;
      unsigned long long sum_idle, sum_time;
      static HANDLE hlib = NULL;
      static NTSTATUS NTAPI (*lib_NtQuerySystemInformation)
	(SYSTEM_INFORMATION_CLASS  SystemInformationClass,
	 PVOID  SystemInformation,
	 ULONG  SystemInformationLength,
	 PULONG  ReturnLength) = NULL;

      if (!hlib)
	hlib = LoadLibrary ("ntdll");
      if (!hlib)
	return 1;
      if (!lib_NtQuerySystemInformation)
	lib_NtQuerySystemInformation =
	  (void *)GetProcAddress (hlib, "NtQuerySystemInformation");
      if (!lib_NtQuerySystemInformation)
	return 1;
      if (lib_NtQuerySystemInformation (SystemProcessorTimes, pt, sizeof pt,
					&retlen) == STATUS_SUCCESS)
	{
	  sum_idle = sum_time = 0;
	  for (i = 0; i < retlen / sizeof pt[0]; i++)
	    {
	      sum_idle += pt[i].pt.IdleTime.QuadPart;
	      sum_time += pt[i].pt.KernelTime.QuadPart;
	      sum_time += pt[i].pt.UserTime.QuadPart;
	    }
	  nowtime = (DWORD)(sum_time / i / 10000ULL);
	  nowidle = (DWORD)(sum_idle / i / 10000ULL);
	  return 0;
	}
      else
	{
	  return 1;
	}
    }
  if (opt_w)
    {
      i = regaccess ("StatData", 1);
      if (i > 100)
	return 1;
      nowtime += 100;
      nowidle += 100 - i;
      return 0;
    }
  if (DeviceIoControl (hvxd, 1, 0, 0, buf2, 0x3ffc, &dd, 0) == FALSE)
    return 1;
  for (i=3; i<dd; i+=4)
    if (buf2[i] & 2)
      break;
  nowidle = buf2[i-1];
  nowtime = GetTickCount ();
  return 0;
}

void
traymode1 (HWND hwnd)
{
  ShowWindow (hwnd, SW_HIDE /*nShow*/ );
  SetClassLong (hwnd, GCL_HICON, (LONG)hexeicon);
  SetWindowText (hwnd, "cpu%.exe");
  traymode = 1;
  if (opt_S)
    traywnd = FindWindow ("Shell_TrayWnd", 0);
}

void
AddIconToTaskbar (HWND hwnd, char *tip)
{
  NOTIFYICONDATA tnd;
  tnd.cbSize = sizeof(NOTIFYICONDATA);
  tnd.hWnd = hwnd;
  tnd.uID = 1;

  tnd.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
  tnd.uCallbackMessage = WM_USER;
  tnd.hIcon = hicon;
  lstrcpy (tnd.szTip, tip);
  if (!opt_i)
    if (Shell_NotifyIcon (NIM_ADD, &tnd))
      {
	traymode1 (hwnd);
	return;
      }
  SetClassLong (hwnd, GCL_HICON, (LONG)hicon);
  SetWindowText (hwnd, tip);
  ShowWindow (hwnd, SW_SHOW | SW_MINIMIZE /*nShow*/ );
  SendMessage (hwnd, WM_PAINTICON, TRUE, 0);
}

void
ModifyIconOnTaskbar (HWND hwnd, char *tip)
{
  NOTIFYICONDATA tnd;

  tnd.cbSize = sizeof(NOTIFYICONDATA);
  tnd.hWnd = hwnd;
  tnd.uID = 1;
  tnd.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
  tnd.uCallbackMessage = WM_USER;
  tnd.hIcon = hicon;
  lstrcpy (tnd.szTip, tip);
  if (traymode)
    {
      if (Shell_NotifyIcon (NIM_MODIFY, &tnd))
	{
	  if (traymode == 2)
	    traymode1 (hwnd);
	  if (IsWindowVisible (hwnd)) /* ver.1.12 */
	    ShowWindow (hwnd, SW_HIDE);	/* ver.1.12 */
	}
      else
	{
#if 0				/* ver.1.12 */
	  void DeleteIconOnTaskbar (HWND hwnd);
	  DeleteIconOnTaskbar (hwnd);
#endif /* ver.1.12 */
	  AddIconToTaskbar (hwnd, tip);
	}
    }
  else
    AddIconToTaskbar (hwnd, tip);
}

void
DeleteIconOnTaskbar (HWND hwnd)
{
  NOTIFYICONDATA tnd;
  tnd.cbSize = sizeof (NOTIFYICONDATA);
  tnd.hWnd = hwnd;
  tnd.uID = 1;

  tnd.uFlags = 0;
  if (traymode)
    traymode = Shell_NotifyIcon (NIM_DELETE, &tnd) ? 0 : 2;
}

int
check_RS (void)
{
  if (opt_R)
    {
      if (GetSystemMetrics (SM_CXSCREEN) != screenx ||
	  GetSystemMetrics (SM_CYSCREEN) != screeny)
	return 1;
    }
  if (opt_S && traywnd)
    {
      HWND d;
      int sx, sy;
      
      sx = GetSystemMetrics (SM_CXSCREEN);
      sy = GetSystemMetrics (SM_CYSCREEN);
      d = GetWindow (traywnd, GW_HWNDPREV);
      while (d)
	{
	  if (IsWindowVisible (d))
	    {
	      RECT rc;

	      if (GetWindowRect (d, &rc))
		{
		  if (rc.left <= 0 && rc.top <= 0 &&
		      rc.right >= sx && rc.bottom >= sy)
		    return 1;
		}
	    }
	  d = GetWindow (d, GW_HWNDPREV);
	}
    }
  return 0;
}

LRESULT CALLBACK
MainWndProc (HWND hwnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
  switch (nMsg)
    {
    case WM_CREATE:
      return 0;

    case WM_DESTROY:
      PostQuitMessage (0);
      return 0;
      
    case WM_TIMER:
      if (wParam == 1)
	{
	  char buf[32];
	  DWORD x;
	  HICON hicon2;
	  int r;
	  int flagRS;

	  flagRS = check_RS ();
	  if (flagRS && opt_F)
	    return 0;
	  oldtime = nowtime;
	  oldidle = nowidle;
	  r =  getcpu ();
	  if (oldtime == nowtime && r == 0)
	    return 0;
	  if (!r)
	    {
	      x = 10000-10000*(nowidle-oldidle)/(nowtime-oldtime);
	      if (ntmode)
		{
		  if (x > 20000)
		    x = 0;
		}
	      wsprintf (buf, "%lu.%02lu %%", x/100, x%100UL);
	      next_data (hwnd, x);
	    }
	  else
	    {
	      next_data (hwnd, -1);
	      lstrcpy (buf, "Error");
	    }
	  if (!flagRS)
	    {
	      hicon2 = hicon;
	      hicon = do_createicon ();
	      if (!hicon)
		hicon = hexeicon;
	      ModifyIconOnTaskbar (hwnd, buf);
	      if (hicon2 != hexeicon)
		DestroyIcon (hicon2);
	    }
	  return 0;
	}
      break;

    case WM_USER:
      if (lParam == WM_RBUTTONUP) /* v1.12 */
	{
	  static int flag = 0;
	  POINT	pt;

	  if (flag)
	    break;
	  flag = 1;
	  GetCursorPos (&pt);
	  if (!SetForegroundWindow (hwnd))
	    {			/* ver.1.12 */
	      HWND h;
	      RECT rc;

	      h = CreateWindowEx (WS_EX_TOOLWINDOW, "BUTTON", "", WS_POPUP |
				  WS_MINIMIZE, 0, 0, 0, 0, hwnd, 0, hinst, 0);
	      GetWindowRect (h, &rc);
	      SetWindowPos (h, 0, -rc.right, -rc.bottom, 0, 0, SWP_NOACTIVATE |
			    SWP_NOCOPYBITS);
	      ShowWindow (h, SW_SHOW);
	      SetForegroundWindow (h);
	      ShowWindow (h, SW_RESTORE);
	      SetForegroundWindow (hwnd);
	      DestroyWindow (h);
	      if (GetForegroundWindow () != hwnd)
		flag = 0;
	    }
	  if (flag)
	    {
	      TrackPopupMenu (hmenu,
			      TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
			      pt.x, pt.y, 0, hwnd, 0);
	      flag = 0;
	    }
	}
      break;

    case WM_COMMAND:
      if (!HIWORD(wParam))
	{
	  SendMessage (hwnd, WM_SYSCOMMAND, LOWORD(wParam), 0);
	  return 0;
	}
      break;

    case WM_SYSCOMMAND:
      switch (wParam)
	{
	case ID_ABOUT:
	  EnableMenuItem (hmenu, ID_ABOUT, MF_BYCOMMAND | MF_GRAYED);
	  EnableMenuItem (hmenu, ID_OPTIONS, MF_BYCOMMAND | MF_GRAYED);
	  EnableMenuItem (hmenu, 1, MF_BYPOSITION | MF_GRAYED);
	  aboutdlg (hwnd);
	  EnableMenuItem (hmenu, 1, MF_BYPOSITION | MF_ENABLED);
	  EnableMenuItem (hmenu, ID_ABOUT, MF_BYCOMMAND | MF_ENABLED);
	  EnableMenuItem (hmenu, ID_OPTIONS, MF_BYCOMMAND | MF_ENABLED);
	  return 0;
	case ID_OPTIONS:
	  EnableMenuItem (hmenu, ID_ABOUT, MF_BYCOMMAND | MF_GRAYED);
	  EnableMenuItem (hmenu, ID_OPTIONS, MF_BYCOMMAND | MF_GRAYED);
	  EnableMenuItem (hmenu, 1, MF_BYPOSITION | MF_GRAYED);
	  optionsdlg (hwnd);
	  EnableMenuItem (hmenu, 1, MF_BYPOSITION | MF_ENABLED);
	  EnableMenuItem (hmenu, ID_ABOUT, MF_BYCOMMAND | MF_ENABLED);
	  EnableMenuItem (hmenu, ID_OPTIONS, MF_BYCOMMAND | MF_ENABLED);
	  return 0;
	}
      break;

    case WM_QUERYOPEN:
      return 0;

    case WM_INITMENUPOPUP:
      if ((HMENU)wParam == hmenu)
	{
	  if (!IsWindowVisible (hwnd))
	    EnableMenuItem (hmenu, 0, MF_BYPOSITION | MF_GRAYED);
	  return 0;
	}
      break;
    }

  return DefWindowProc (hwnd, nMsg, wParam, lParam);
}

int STDCALL
WinMain (HINSTANCE hInst, HINSTANCE hPrev, LPSTR lpCmd, int nShow)
{
  HWND hwndMain2, hwndMain;
  MSG msg;
  WNDCLASSEX wndclass;
  char classname[] = "cpu%";
  char *pp, *p;
  int i, j, k;
  int opt_h = 0, opt_err = 0;
  int opt_1 = 0;
  HANDLE hsem = 0;

  InitCommonControls ();
  nowtime = 0;
  nowidle = 0;
  ntmode = 0;
  traymode = 0;
  {
    OSVERSIONINFO d;

    d.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
    GetVersionEx (&d);
    if (d.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) /* Chicago */
      ntmode = 0;
    else
      ntmode = 1;
    loadoptions (d.dwMajorVersion >= 6);
  }
  opt_i = 0;
  opt_t = 0;
  opt_w = 0;
  opt_R = 0;
  opt_F = 0;
  opt_S = 0;
  j = strlen (lpCmd);
  pp = p = LocalAlloc (LMEM_FIXED, j + 5);
  if (!p)
    return 0;
  for (i = k = 0 ; i < j ; i++)
    {
      if (lpCmd[i] == ' ')
	{
	  p[k] = 0;
	  continue;
	}
      if (k != 0 && p[k] == 0)
	k++;
      p[k++] = lpCmd[i];
      p[k] = ' ';
    }
  p[k++] = 0;
  p[k++] = 0;

  for (;;)
    {
      if (p[0] == 0)
	break;
      j = strlen (p);
      if (p[0] == '-')
	{
	  for (i = 1 ; i < j ; i++)
	    {
	      switch (p[i])
		{
		case 'i':
		  opt_i = 1;
		  break;
		case 'h':
		  opt_h = 1;
		  break;
		case 't':
		  opt_t = 1;
		  break;
		case 'c':
		  ntmode = 0;
		  break;
		case 'n':
		  ntmode = 1;
		  break;
		case 'w':
		  opt_w = 1;
		  break;
		case 'R':
		  opt_R = 1;
		  break;
		case 'F':
		  opt_F = 1;
		  break;
		case 'S':
		  opt_S = 1;
		  break;
		case '1':
		  opt_1 = 1;
		  break;
		default:
		  opt_err = 1;
		}
	    }
	}
      p += j + 1;
    }
  LocalFree (pp);

  if (opt_1)
    {
      TCHAR a[MAX_PATH];

      j = GetModuleFileName (0, a, MAX_PATH);
      for (i = 0 ; i < j ; i++)
	if (a[i] == TEXT ('/') || a[i] == TEXT ('\\'))
	  a[i] = TEXT (':');
      hsem = CreateSemaphore (0, 0, 1, a);
      if (hsem && GetLastError () == ERROR_ALREADY_EXISTS)
	CloseHandle (hsem), hsem = 0;
      if (!hsem)
	return 0;
    }

  hexeicon = LoadIcon (hInst, MAKEINTRESOURCE (IDI_ICON1));
  memset (&wndclass, 0, sizeof(WNDCLASSEX));
  wndclass.lpszClassName = classname;
  wndclass.cbSize = sizeof(WNDCLASSEX);
  wndclass.style = 0;
  wndclass.lpfnWndProc = MainWndProc;
  wndclass.hInstance = hInst;
  wndclass.hIcon = hexeicon; /* LoadIcon (NULL, IDI_APPLICATION); */
  wndclass.hIconSm = 0; /* LoadIcon (NULL, IDI_APPLICATION); */
  wndclass.hCursor = LoadCursor (NULL, IDC_ARROW);
  wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH);

  RegisterClassEx (&wndclass);

  if (opt_t)
    hwndMain2 = 0;
  else
    hwndMain2 = CreateWindow (classname, "",
			      WS_OVERLAPPEDWINDOW,
			      CW_USEDEFAULT, CW_USEDEFAULT, 0,
			      0, NULL, NULL, hInst, NULL);
  
  hwndMain = CreateWindow (classname, "",
			   WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU
			   | WS_MINIMIZE,
			   CW_USEDEFAULT, CW_USEDEFAULT, 0,
			   0, hwndMain2, NULL, hInst, NULL);

  if (opt_R)
    {
      screenx = GetSystemMetrics (SM_CXSCREEN);
      screeny = GetSystemMetrics (SM_CYSCREEN);
    }
  
  if (opt_h)
    MessageBox (hwndMain, "Usage: cpu%.exe [OPTIONS]\n"
		"\n"
		"  -h    display this help and exit\n"
		"  -i    do not use Shell_NotifyIcon\n"
		"  -t    show in taskbar\n"
		"  -n    force mode Windows NT\n"
		"  -c    force mode Windows 9x\n"
		"  -w    do not use WINTOP.VXD\n"
		"  -R    monitor screen size\n"
		"  -S    monitor full screen window\n"
		"  -F    faster (with -R or -S)\n"
		"  -1    exit if another cpu%.exe is running\n"
		, "cpu%", MB_OK | MB_ICONINFORMATION);
  else
    {
      if (opt_err)
	MessageBox (hwndMain, "there were unrecognized options",
		    "cpu%: Warning", MB_OK);

      if (!ntmode && !opt_w)
	hvxd = CreateFile ("\\\\.\\WINTOP.VXD",0,0,0,0,0x4000000,0);
      else
	hvxd = INVALID_HANDLE_VALUE;
      if (hvxd == INVALID_HANDLE_VALUE && ntmode == 0 && opt_w == 0)
	{
	  MessageBox (hwndMain, "can't open WINTOP.VXD",
		      "cpu%: Warning", MB_OK);
	  /* PostQuitMessage (0); */
	  opt_w = 1;
	}
      /* else */
      if (opt_w)
	{
	  regaccess ("StartSrv", 0);
	  regaccess ("StartStat", 1);
	}
      {
	DWORD dd;
	unsigned long firstbuf;
	if (!ntmode && !opt_w)
	  {
	    if (DeviceIoControl (hvxd, 2, 0, 0, &firstbuf, sizeof (firstbuf),
				 &dd, 0) == FALSE)
	      {
		MessageBox (hwndMain, "can't do DeviceIoControl",
			    "cpu%: Error", MB_OK);
		PostQuitMessage (0);
	      }
	    else
	      (void) getcpu ();
	  }
	else
	  (void) getcpu ();
      }
      
      ShowWindow (hwndMain, SW_HIDE /*nShow*/ );
      /* UpdateWindow (hwndMain); */

      hicon = do_createicon ();
      if (!hicon)
	hicon = hexeicon;
      hmenu = GetSystemMenu (hwndMain, FALSE);
      DeleteMenu (hmenu, 0, MF_BYPOSITION);
      DeleteMenu (hmenu, 1, MF_BYPOSITION);
      DeleteMenu (hmenu, 1, MF_BYPOSITION);
      DeleteMenu (hmenu, 1, MF_BYPOSITION);
      DeleteMenu (hmenu, 1, MF_BYPOSITION);
      /* DeleteMenu (hmenu, 0, MF_BYPOSITION); */
      AppendMenu (hmenu, MF_SEPARATOR, 0, 0);
      AppendMenu (hmenu, MF_STRING, ID_OPTIONS, "&Options...");
      AppendMenu (hmenu, MF_STRING, ID_ABOUT, "&About...");
      AddIconToTaskbar (hwndMain, "cpu%.exe");

      hinst = hInst;
      SetTimer (hwndMain, 1, opt.interval, NULL);
      
      while (GetMessage (&msg, NULL, 0, 0))
	{
	  TranslateMessage (&msg);
	  DispatchMessage (&msg);
	}
      
      KillTimer (hwndMain, 1);

      DeleteIconOnTaskbar (hwndMain);
      DestroyIcon (hicon);
  
      if (hvxd != INVALID_HANDLE_VALUE)
	CloseHandle (hvxd);
      if (opt_w)
	{
	  regaccess ("StopStat", 1);
	  regaccess ("StopSrv", 0);
	}
      if (opt_1)
	CloseHandle (hsem);
    }
  
  return msg.wParam;
}

